#ifndef MESURE_H
#define MESURE_H

#include <stdarg.h>

class courant
{
  private:
    int u1RAW;
    int u2RAW;
    int r;
    uint8_t pinPWM;
    uint8_t pinU1;
    uint8_t pinU2;
    double u1;
    double u2;
    uint8_t bridgeU1Enable;
    uint8_t bridgeU2Enable;
    double bridgeU1RapportR;
    double bridgeU2RapportR;
    void lireTension();
  public:
    courant(uint8_t pinU1, uint8_t pinU2, int r);
    courant(uint8_t pinU1, uint8_t pinU2, int r, uint8_t bridgeU1Enable, uint8_t bridgeU2Enable, ...);
    void config(uint8_t pinU1, uint8_t pinU2, int r);
    void config(uint8_t pinU1, uint8_t pinU2, int r, uint8_t bridgeU1, uint8_t bridgeU2, ...);
    double lireCourant();
    double lireTensionU1();
    double lireTensionU2();
;};

#endif
